/*
 * This pseudo js class is meant to accommodate an iframe
 * that requires lengthy parameters that surpass limitations of GET verb.
 */
var MM_iFrame = Class.extend({
	
	/*
	 * @url is the full url to the iframe endpoint.
	 * @iframeId is the ID of the iframe.
	 */
	init : function(url, iframeId) {
		this.iframeUrl = url;
		this.iframeId = iframeId;

		// / *pseudo private class vars
		this.formId = "mm-user-defined-form";
		this.appendToId = "body";
		this.formObj = null;

		// / call setup function for this form
		this.setupForm();
	},

	/*
	 * Setup the form needed to run a post to the iframe.
	 * Appends form to the body of the page.
	 */
	setupForm : function() {
		this.formObj = $('<form action="' + this.iframeUrl + '" target="'
				+ this.iframeId + '" method="post" style="display:none;" id="'
				+ this.formId + '" name="' + this.formId + '"></form>');
		$(this.appendToId).append(this.formObj);
	},

	/*
	 * @params is a json array of name/value pairs.
	 * Appends hidden inputs to our existing form object.
	 */
	addParameters : function(params) {
		var data = jQuery.parseJSON(params);
		for ( var name in data) {
			var value = data[name];
			if (jQuery.type(value) != "string"
					&& jQuery.type(value) != "number"
					&& jQuery.type(value) != "boolean") {
				value = JSON.stringify(value);
			}
			$("<input type='hidden' />").attr("name", name)
					.attr("value", value).appendTo(this.formObj);
		}
	},

	/*
	 * Submits existing form to the iframe and removes it from page.
	 */
	submit : function() {
		this.formObj.submit().remove();
	}
});