stripe = Stripe(stripeElementsInfo.stripePublishableKey);

var MM_StripeElements = Class.extend({ 
	 
	pageObject: {},
	stripe: {},
	elements: {}, 
	card: {}, 
	
	init: function()
	{     
		if ((typeof myaccount_js !== 'undefined') && (myaccount_js instanceof MM_MyAccountView))
		{
			 console.log("Is my account .. ");
		}	
		else
		{
			this.load();
		}
	},
	
	createElementDiv: function(el, wrapperID) {  
		var wrapper = document.createElement('div');
		wrapper.id = wrapperID;
	    el.parentNode.insertBefore(wrapper, el);
	    wrapper.appendChild(el);
	}, 
	  
	load: function()
	{
		console.log("Building... loading form elements !");
		this.stripe = Stripe(stripeElementsInfo.stripePublishableKey); 
		 
		/*
		 * Wrap current elements with divs of which we can overwrite.
		 */ 	
		//
		this.createElementDiv(document.getElementById('mm_field_cc_number'), "mm_field_cc_number_div");
		this.createElementDiv(document.getElementById('mm_field_cc_cvv'), "mm_field_cc_cvv_div");
		if(!mmStripeElements.myAccount)
		{  
			this.createElementDiv(document.getElementById('mm-checkout-expiration-date'), "mm_field_cc_exp_div");
		}
		
		this.elements = this.stripe.elements();
   
		this.card = this.elements.create('cardNumber', {});
		this.card.mount('#mm_field_cc_number_div');
		
		var cardExpiry = this.elements.create('cardExpiry', {});
		if(mmStripeElements.myAccount)
		{  
			cardExpiry.mount('#mm_field_cc_exp_month_row');
		}
		else
		{
			cardExpiry.mount('#mm_field_cc_exp_div');
		}
		 
		var cardCvc = this.elements.create('cardCvc', {});
		cardCvc.mount('#mm_field_cc_cvv_div');  

		// Handle real-time validation errors from the card Element.
		 this.card.addEventListener('change', function(event) {
		  var displayError = document.getElementById('card-errors');
		  if(displayError!=undefined && displayError!=null){ 
			  if (event.error) {
			    displayError.textContent = event.error.message;
			  } else {
			    displayError.textContent = '';
			  }
		  }
		  else{
			  if (event.error) {
				  console.log("Error with Stripe Elements: ");
				  console.log(event.error);
				  mmStripeElements.errorHandler(event.error.message);
			  }
		  }
		}); 
	},
	
	buildForm: function()
	{   
		mmStripeElements.load();
	},
	
	errorHandler: function(errorMessage)
	{ 
		alert(errorMessage);
	}, 
	  
	doTokenExchange: function()
	{   
		mmStripeElements.pageObject.isElements = true; 
		console.log(mmStripeElements.card);
		mmStripeElements.stripe.createToken(mmStripeElements.card).then(function(result) { 
			console.log(result);
			
		    if (result.error) {   
				var errorMessage = result.error.message;
				mmStripeElements.errorHandler(errorMessage);
				
		    } else {   
		    	if (mmStripeElements.myAccount)
			    { 
			    	mmStripeElements.pageObject.addPaymentTokenToForm(result.token.id);  
		    		mmStripeElements.pageObject.doSubscriptionBillingUpdate(); 
			    }
		    	else{ 
			    	mmStripeElements.pageObject.addPaymentTokenToForm(result.token.id);  
			    	mmStripeElements.pageObject.submitCheckoutForm(false); 
		    	}
		    	return true;
		    }
		});
		return false; 
	}
}); 

var mmStripeElements = new MM_StripeElements();  

if ((typeof myaccount_js !== 'undefined') && (myaccount_js instanceof MM_MyAccountView))
{
	//my account page
	mmStripeElements.myAccount = true;
	mmStripeElements.pageObject = myaccount_js;   
	mmStripeElements.pageObject.isElements = true;
	myaccount_js.addPreUpdateCallback('onsite',mmStripeElements.doTokenExchange); 
}
else
{
	//checkout page 
	mmStripeElements.pageObject = mmjs;      
	mmStripeElements.pageObject.isElements = true;
	mmjs.addPrecheckoutCallback('onsite',mmStripeElements.doTokenExchange);
} 